package dictionarybuilder;

import java.io.*;

/**
 * 
 *
 * @author quasiyoke
 */
public class EasyAccessSolitaryFile extends EasyAccessFile{

private RandomAccessFile randomAccessFile;

public EasyAccessSolitaryFile(File file,boolean resolveWriting) throws
	IOException{
    super(file,resolveWriting);
    randomAccessFile=new RandomAccessFile(file,resolveWriting?"rw":"r");
}

public EasyAccessSolitaryFile(String filePath,boolean resolveWriting) throws
	IOException{
    this(new File(filePath),resolveWriting);
}

public void close() throws IOException{
    randomAccessFile.close();
}

public char readChar() throws IOException{
    char result=randomAccessFile.readChar();
    filePointer+=2;
    return result;
}

public int readInt() throws IOException{
    int result=randomAccessFile.readInt();
    filePointer+=4;
    return result;
}

public int readUnsignedByte() throws IOException{
    int result=randomAccessFile.readUnsignedByte();
    filePointer++;
    return result;
}

public void seek(long position) throws IOException{
    randomAccessFile.seek(position);
    filePointer=position;
}

public void skipBytes(int bytesCount) throws IOException{
    if(bytesCount>0){
	randomAccessFile.skipBytes(bytesCount);
	filePointer+=bytesCount;
    }
}

public void writeByte(int nByte) throws IOException{
    randomAccessFile.writeByte(nByte);
    filePointer++;
}

public void writeChar(char character) throws IOException{
    randomAccessFile.writeChar(character);
    filePointer+=2;
}

public void writeInt(int number) throws IOException{
    randomAccessFile.writeInt(number);
    filePointer+=4;
}

}
