import java.io.*;
import java.util.*;

/**
 * 
 *
 * @author quasiyoke
 */
public final class LexicalBase{

private final static int NULL_INT_VALUE=-2;

/**
 * Все словари доступные программе. Отсортированы.
 */
private final Dictionary[] DICTIONARIES;

private static String[] dictionariesPaths;

private static LexicalBase instance;

private LexicalBase(){
    int j;
    Vector dictionaries=new Vector();
    for(j=0;j<dictionariesPaths.length;j++){
        try{
            dictionaries.addElement(new Dictionary(dictionariesPaths[j]));
        }catch(IOException e){
            PieceOfDictionary.showError(PieceOfDictionary.replace(Language.
                    getCurrentLanguageInscription("no_dictionary_error"),
                    PieceOfDictionary.STRING_ESCAPE[0],dictionariesPaths[j])+e.
                    toString());
        }
    }
    DICTIONARIES=new Dictionary[dictionaries.size()];
    for(j=0;j<DICTIONARIES.length;j++){
        DICTIONARIES[j]=(Dictionary)dictionaries.elementAt(j);
    }
    PieceOfDictionary.sort(DICTIONARIES);
}

public Dictionary[] getDictionaries(){
    return DICTIONARIES;
}

public static LexicalBase getInstance(){
    return instance==null?instance=new LexicalBase():instance;
}

public void matchKeysCharsAndAlphabets(char[][] keysChars){
    int j;
    for(j=0;j<DICTIONARIES.length;j++){
        DICTIONARIES[j].matchKeysCharsAndAlphabet(keysChars);
    }
}

public static void setDictionariesPaths(Vector dictionariesPaths){
    LexicalBase.dictionariesPaths=new String[dictionariesPaths.size()];
    int j;
    for(j=0;j<LexicalBase.dictionariesPaths.length;j++){
        LexicalBase.dictionariesPaths[j]=(String)dictionariesPaths.elementAt(j);
    }
}

/**
 * Набор вхождений последовательности нажатий клавиш во все словари.
 */
class OccurrencesSet implements Collection{

private int articlesCount=NULL_INT_VALUE;

private Dictionary.HeadsSet[] headsSet;

/**
 * Длина последовательности клавиш этого набора вхождений в словари.
 */
private int keyLength;

OccurrencesSet(Vector keyChain,int keyChainLength){
    int j;
    headsSet=new Dictionary.HeadsSet[DICTIONARIES.length];
    for(j=0;j<DICTIONARIES.length;j++){
        headsSet[j]=((Dictionary)DICTIONARIES[j]).new HeadsSet(keyChain,
                keyChainLength);
    }
    keyLength=keyChainLength;
}

/**
 * @throws IndexOutOfSomeBoundsException Если нет статьи с заданным индексом.
 */
public Object elementAt(int index) throws IndexOutOfSomeBoundsException{
    if(index<0){
        throw new IndexOutOfSomeBoundsException();
    }
    int j;
    int failuresCount;
    int[] arIndex={index};
    int keyLength=this.keyLength;
    do{
        failuresCount=0;
        for(j=0;j<headsSet.length;j++){
            try{
                return headsSet[j].elementAt(arIndex,keyLength);
            }catch(NoSuchElementException e){
            }catch(IndexOutOfSomeBoundsException e){
                failuresCount++;
            }
        }
        keyLength++;
    }while(failuresCount<headsSet.length);
    throw new IndexOutOfSomeBoundsException();
}

}

}
